This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 452577 - Actual & placeholder funcs have differing param counts
Actual & placeholder funcs have differing param counts
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.2
All Linux
low Severity low
: rc
: ---
Assigned To: Prarit Bhargava
Martin Jenner
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-06-23 16:29 EDT by Steve Snyder
Modified: 2009-01-20 15:25 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-01-20 15:25:41 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Change 4-param macros to match 3-param functions (824 bytes, patch)
2008-06-23 16:29 EDT, Steve Snyder
no flags Details | Diff
RHEL5 fix for this issue (6.24 KB, patch)
2008-06-24 12:01 EDT, Prarit Bhargava
no flags Details | Diff

  None (edit)
Description Steve Snyder 2008-06-23 16:29:41 EDT
Description of problem:

Function xfrm_audit_state_replay(a, b, c) in ~/include/net/xfrm.h is replaced bu
a macro of the same name if the Auditd System Calls feature is not enabled.  The
probalem is that the macro is defined as having 4, not 3, parameters.  The code
that invokes this func/macro only provides 3 parameters.

Version-Release number of selected component (if applicable):

Kernel 2.6.18-92.el5.i686

How reproducible:

Always.

Steps to Reproduce:
1. Disable the Auditd System Calls feature in the kernel
2.  Attempt to rebuild the kernel
3.
  
Actual results:

  CC      net/ipv4/xfrm4_input.o
net/ipv4/xfrm4_input.c:98:39: error: macro "xfrm_audit_state_replay" requires 4
arguments, but only 3 given
net/ipv4/xfrm4_input.c: In function ‘xfrm4_rcv_encap’:
net/ipv4/xfrm4_input.c:98: error: ‘xfrm_audit_state_replay’ undeclared (first
use in this function)
net/ipv4/xfrm4_input.c:98: error: (Each undeclared identifier is reported only once
net/ipv4/xfrm4_input.c:98: error: for each function it appears in.)
make[2]: *** [net/ipv4/xfrm4_input.o] Error 1
make[1]: *** [net/ipv4] Error 2
make: *** [net] Error 2

Expected results:

Placeholder macro should be defined as having the same number of parameters as
the function it is replacing.

Additional info:

Same param count mismatch is also seen with function/macro
xfrm_naudit_state_replay() in same header file.
Comment 1 Steve Snyder 2008-06-23 16:29:41 EDT
Created attachment 310071 [details]
Change 4-param macros to match 3-param functions
Comment 2 Prarit Bhargava 2008-06-24 10:47:59 EDT
Red Hat does not support custom kernel building.  However, custom kernels should
still build :)

Thanks Steve -- I'll see what I can do about getting this into 5.3.

P.
Comment 3 Prarit Bhargava 2008-06-24 12:01:57 EDT
Created attachment 310158 [details]
RHEL5 fix for this issue

Loosely based on original patch -- now fixes compile errors and warning.
Comment 4 RHEL Product and Program Management 2008-06-24 14:05:48 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 6 Don Zickus 2008-09-12 21:47:35 EDT
in kernel-2.6.18-113.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5
Comment 10 errata-xmlrpc 2009-01-20 15:25:41 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-0225.html

Note You need to log in before you can comment on or make changes to this bug.